"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCFExportNameDistributionIdArnFromConfig = exports.getCFExportNameSnsTopicArnFromConfig = exports.getCFExportNameApiKeyIdFromConfig = exports.getCFExportNameUserPoolClientIdFromConfig = exports.getCFExportNameUserPoolIdFromConfig = exports.getQpqRuntimeResourceNameFromConfig = exports.getQpqRuntimeResourceName = exports.getConfigRuntimeResourceNameFromConfig = exports.getConfigRuntimeResourceName = exports.getGlobalQpqRuntimeResourceName = exports.getGlobalConfigRuntimeResourceName = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const getGlobalConfigRuntimeResourceName = (resourceName, application, environment, feature) => {
    const baseName = `${resourceName}-${application}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}`;
    }
    return baseName;
};
exports.getGlobalConfigRuntimeResourceName = getGlobalConfigRuntimeResourceName;
const getGlobalQpqRuntimeResourceName = (resourceName, application, environment, feature, resourceType = '') => {
    const name = (0, exports.getGlobalConfigRuntimeResourceName)(resourceName, application, environment, feature);
    return `${name}-qpq${resourceType}`;
};
exports.getGlobalQpqRuntimeResourceName = getGlobalQpqRuntimeResourceName;
const getConfigRuntimeResourceName = (resourceName, application, service, environment, feature) => {
    const baseName = `${resourceName}-${application}-${service}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}`;
    }
    return baseName;
};
exports.getConfigRuntimeResourceName = getConfigRuntimeResourceName;
const getConfigRuntimeResourceNameFromConfig = (resourceName, qpqConfig) => {
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
};
exports.getConfigRuntimeResourceNameFromConfig = getConfigRuntimeResourceNameFromConfig;
const getQpqRuntimeResourceName = (resourceName, application, service, environment, feature, resourceType = '') => {
    const name = (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
    return `${name}-qpq${resourceType}`;
};
exports.getQpqRuntimeResourceName = getQpqRuntimeResourceName;
const getQpqRuntimeResourceNameFromConfig = (resourceName, qpqConfig, resourceType = '') => {
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(resourceName, application, service, environment, feature, resourceType);
};
exports.getQpqRuntimeResourceNameFromConfig = getQpqRuntimeResourceNameFromConfig;
const getCFExportNameUserPoolIdFromConfig = (userDirectoryName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(userDirectoryName, application, service, environment, feature, 'user-pool-id-export');
};
exports.getCFExportNameUserPoolIdFromConfig = getCFExportNameUserPoolIdFromConfig;
const getCFExportNameUserPoolClientIdFromConfig = (userDirectoryName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(userDirectoryName, application, service, environment, feature, 'user-pool-client-id-export');
};
exports.getCFExportNameUserPoolClientIdFromConfig = getCFExportNameUserPoolClientIdFromConfig;
const getCFExportNameApiKeyIdFromConfig = (apiKeyName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(apiKeyName, application, service, environment, feature, 'api-key-id-export');
};
exports.getCFExportNameApiKeyIdFromConfig = getCFExportNameApiKeyIdFromConfig;
const getCFExportNameSnsTopicArnFromConfig = (eventBusName, qpqConfig, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getGlobalQpqRuntimeResourceName)(eventBusName, application, environment, feature, 'sns-topic-arn-export');
};
exports.getCFExportNameSnsTopicArnFromConfig = getCFExportNameSnsTopicArnFromConfig;
const getCFExportNameDistributionIdArnFromConfig = (webEntryName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(webEntryName, application, service, environment, feature, 'distribution-id-export');
};
exports.getCFExportNameDistributionIdArnFromConfig = getCFExportNameDistributionIdArnFromConfig;
