"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeValidJwt = void 0;
const aws_jwt_verify_1 = require("aws-jwt-verify");
const decodeValidJwt = (userPoolId, clientId, tokenType, accessToken) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    if (!accessToken) {
        return null;
    }
    const verifier = aws_jwt_verify_1.CognitoJwtVerifier.create({
        userPoolId: userPoolId,
        tokenUse: tokenType,
        clientId: clientId,
    });
    try {
        const payload = yield verifier.verify(accessToken);
        return {
            userId: payload.sub,
            username: ((_a = payload.username) === null || _a === void 0 ? void 0 : _a.toString()) || '',
        };
    }
    catch (e) {
        console.log('Invalid jwt token', e);
        return null;
    }
});
exports.decodeValidJwt = decodeValidJwt;
