"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cognitoAdminInitiateAuthResponseToQpqAuthenticationInfo = exports.cognitoAuthenticationResultTypeToQpqAuthenticationInfo = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const cognitoAuthenticationResultTypeToQpqAuthenticationInfo = (authResult, issueDateTime) => {
    // Parse the issueDateTime and add the expiresIn to get the expiration date
    let issueDate = new Date(issueDateTime);
    issueDate.setSeconds(issueDate.getSeconds() + (authResult.ExpiresIn || 0));
    const expiresAt = issueDate.toISOString();
    return {
        accessToken: authResult.AccessToken,
        idToken: authResult.IdToken,
        refreshToken: authResult.RefreshToken,
        tokenType: authResult.TokenType,
        expirationDurationInSeconds: authResult.ExpiresIn,
        expiresAt,
    };
};
exports.cognitoAuthenticationResultTypeToQpqAuthenticationInfo = cognitoAuthenticationResultTypeToQpqAuthenticationInfo;
const cognitoAdminInitiateAuthResponseToQpqAuthenticationInfo = (authResponse, issueDateTime) => {
    const res = {
        session: authResponse.Session,
        challenge: quidproquo_core_1.AuthenticateUserChallenge.NONE,
    };
    if (authResponse.AuthenticationResult) {
        res.authenticationInfo = (0, exports.cognitoAuthenticationResultTypeToQpqAuthenticationInfo)(authResponse.AuthenticationResult, issueDateTime);
    }
    return res;
};
exports.cognitoAdminInitiateAuthResponseToQpqAuthenticationInfo = cognitoAdminInitiateAuthResponseToQpqAuthenticationInfo;
