"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getItem = void 0;
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
function getItem(tableName, key, region) {
    return __awaiter(this, void 0, void 0, function* () {
        const dynamoDBClient = new client_dynamodb_1.DynamoDBClient({ region });
        const getItemParams = {
            TableName: tableName,
            Key: {
                key: {
                    S: key,
                },
            },
        };
        try {
            const result = yield dynamoDBClient.send(new client_dynamodb_1.GetItemCommand(getItemParams));
            return result.Item ? JSON.parse(result.Item.value.S) : null;
        }
        catch (error) {
            console.error('Error getting item from DynamoDB:', error);
            throw error;
        }
    });
}
exports.getItem = getItem;
