"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.putItem = void 0;
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
function putItem(tableName, key, value, options, region) {
    return __awaiter(this, void 0, void 0, function* () {
        const dynamoClient = new client_dynamodb_1.DynamoDBClient({ region });
        yield dynamoClient.send(new client_dynamodb_1.PutItemCommand({
            TableName: tableName,
            Item: Object.assign({ key: { S: key }, value: { S: JSON.stringify(value) } }, (options.expires ? { expires: { N: options.expires.toString() } } : {})),
        }));
    });
}
exports.putItem = putItem;
