"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateItem = void 0;
const client_dynamodb_1 = require("@aws-sdk/client-dynamodb");
// THIS DOES NOT WORK ~ DO NOT USE
function updateItem(tableName, key, value, options = {}, region) {
    return __awaiter(this, void 0, void 0, function* () {
        const dynamoClient = new client_dynamodb_1.DynamoDBClient({ region });
        const updateExpressions = Object.keys(value).map((attr, idx) => {
            return `SET #value.#${attr} = :${attr}`;
        });
        const expressionAttributeNames = Object.assign({ '#value': 'value' }, Object.keys(value).reduce((obj, attr) => {
            obj[`#${attr}`] = attr;
            return obj;
        }, {}));
        const expressionAttributeValues = Object.keys(value).reduce((obj, attr) => {
            obj[`:${attr}`] = { S: JSON.stringify(value[attr]) };
            return obj;
        }, {});
        if (options.expires) {
            updateExpressions.push('SET expires = :expires');
            expressionAttributeValues[':expires'] = { N: options.expires.toString() };
        }
        const updateItemParams = {
            TableName: tableName,
            Key: {
                key: {
                    S: key,
                },
            },
            UpdateExpression: updateExpressions.join(', '),
            ExpressionAttributeNames: expressionAttributeNames,
            ExpressionAttributeValues: expressionAttributeValues,
        };
        console.log('updateItemParams:', JSON.stringify(updateItemParams, null, 2));
        try {
            yield dynamoClient.send(new client_dynamodb_1.UpdateItemCommand(updateItemParams));
        }
        catch (error) {
            console.error('Error updating item:', error);
            throw error;
        }
    });
}
exports.updateItem = updateItem;
