"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sendMessages = void 0;
const client_sqs_1 = require("@aws-sdk/client-sqs");
const getQueueUrl_1 = require("./getQueueUrl");
const sendMessages = (queueName, region, messages) => __awaiter(void 0, void 0, void 0, function* () {
    const sqsClient = new client_sqs_1.SQSClient({
        region,
    });
    const url = yield (0, getQueueUrl_1.getQueueUrl)(queueName, sqsClient);
    // Convert them to entries
    const entries = messages.map((message, index) => ({
        MessageBody: message,
        Id: `${index}`,
    }));
    // now send them off in batches of 10
    // We want to await incase of FIFO
    // If you don't care about order, you can split and askParallel outside of this
    while (entries.length > 0) {
        // Max batch size is 10
        const entriesBatch = entries.splice(0, 10);
        yield sqsClient.send(new client_sqs_1.SendMessageBatchCommand({
            Entries: entriesBatch,
            QueueUrl: url,
        }));
    }
});
exports.sendMessages = sendMessages;
